/*
CryptoJS v3.1.2
code.google.com/p/crypto-js
(c) 2009-2013 by Jeff Mott. All rights reserved.
code.google.com/p/crypto-js/wiki/License
*/
var CryptoJS=CryptoJS||function(e,m){var p={},j=p.lib={},l=function(){},f=j.Base={extend:function(a){l.prototype=this;var c=new l;a&&c.mixIn(a);c.hasOwnProperty("init")||(c.init=function(){c.$super.init.apply(this,arguments)});c.init.prototype=c;c.$super=this;return c},create:function(){var a=this.extend();a.init.apply(a,arguments);return a},init:function(){},mixIn:function(a){for(var c in a)a.hasOwnProperty(c)&&(this[c]=a[c]);a.hasOwnProperty("toString")&&(this.toString=a.toString)},clone:function(){return this.init.prototype.extend(this)}},
n=j.WordArray=f.extend({init:function(a,c){a=this.words=a||[];this.sigBytes=c!=m?c:4*a.length},toString:function(a){return(a||h).stringify(this)},concat:function(a){var c=this.words,q=a.words,d=this.sigBytes;a=a.sigBytes;this.clamp();if(d%4)for(var b=0;b<a;b++)c[d+b>>>2]|=(q[b>>>2]>>>24-8*(b%4)&255)<<24-8*((d+b)%4);else if(65535<q.length)for(b=0;b<a;b+=4)c[d+b>>>2]=q[b>>>2];else c.push.apply(c,q);this.sigBytes+=a;return this},clamp:function(){var a=this.words,c=this.sigBytes;a[c>>>2]&=4294967295<<
32-8*(c%4);a.length=e.ceil(c/4)},clone:function(){var a=f.clone.call(this);a.words=this.words.slice(0);return a},random:function(a){for(var c=[],b=0;b<a;b+=4)c.push(4294967296*e.random()|0);return new n.init(c,a)}}),b=p.enc={},h=b.Hex={stringify:function(a){var c=a.words;a=a.sigBytes;for(var b=[],d=0;d<a;d++){var f=c[d>>>2]>>>24-8*(d%4)&255;b.push((f>>>4).toString(16));b.push((f&15).toString(16))}return b.join("")},parse:function(a){for(var c=a.length,b=[],d=0;d<c;d+=2)b[d>>>3]|=parseInt(a.substr(d,
2),16)<<24-4*(d%8);return new n.init(b,c/2)}},g=b.Latin1={stringify:function(a){var c=a.words;a=a.sigBytes;for(var b=[],d=0;d<a;d++)b.push(String.fromCharCode(c[d>>>2]>>>24-8*(d%4)&255));return b.join("")},parse:function(a){for(var c=a.length,b=[],d=0;d<c;d++)b[d>>>2]|=(a.charCodeAt(d)&255)<<24-8*(d%4);return new n.init(b,c)}},r=b.Utf8={stringify:function(a){try{return decodeURIComponent(escape(g.stringify(a)))}catch(c){throw Error("Malformed UTF-8 data");}},parse:function(a){return g.parse(unescape(encodeURIComponent(a)))}},
k=j.BufferedBlockAlgorithm=f.extend({reset:function(){this._data=new n.init;this._nDataBytes=0},_append:function(a){"string"==typeof a&&(a=r.parse(a));this._data.concat(a);this._nDataBytes+=a.sigBytes},_process:function(a){var c=this._data,b=c.words,d=c.sigBytes,f=this.blockSize,h=d/(4*f),h=a?e.ceil(h):e.max((h|0)-this._minBufferSize,0);a=h*f;d=e.min(4*a,d);if(a){for(var g=0;g<a;g+=f)this._doProcessBlock(b,g);g=b.splice(0,a);c.sigBytes-=d}return new n.init(g,d)},clone:function(){var a=f.clone.call(this);
a._data=this._data.clone();return a},_minBufferSize:0});j.Hasher=k.extend({cfg:f.extend(),init:function(a){this.cfg=this.cfg.extend(a);this.reset()},reset:function(){k.reset.call(this);this._doReset()},update:function(a){this._append(a);this._process();return this},finalize:function(a){a&&this._append(a);return this._doFinalize()},blockSize:16,_createHelper:function(a){return function(c,b){return(new a.init(b)).finalize(c)}},_createHmacHelper:function(a){return function(b,f){return(new s.HMAC.init(a,
f)).finalize(b)}}});var s=p.algo={};return p}(Math);
(function(){var e=CryptoJS,m=e.lib,p=m.WordArray,j=m.Hasher,l=[],m=e.algo.SHA1=j.extend({_doReset:function(){this._hash=new p.init([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(f,n){for(var b=this._hash.words,h=b[0],g=b[1],e=b[2],k=b[3],j=b[4],a=0;80>a;a++){if(16>a)l[a]=f[n+a]|0;else{var c=l[a-3]^l[a-8]^l[a-14]^l[a-16];l[a]=c<<1|c>>>31}c=(h<<5|h>>>27)+j+l[a];c=20>a?c+((g&e|~g&k)+1518500249):40>a?c+((g^e^k)+1859775393):60>a?c+((g&e|g&k|e&k)-1894007588):c+((g^e^
k)-899497514);j=k;k=e;e=g<<30|g>>>2;g=h;h=c}b[0]=b[0]+h|0;b[1]=b[1]+g|0;b[2]=b[2]+e|0;b[3]=b[3]+k|0;b[4]=b[4]+j|0},_doFinalize:function(){var f=this._data,e=f.words,b=8*this._nDataBytes,h=8*f.sigBytes;e[h>>>5]|=128<<24-h%32;e[(h+64>>>9<<4)+14]=Math.floor(b/4294967296);e[(h+64>>>9<<4)+15]=b;f.sigBytes=4*e.length;this._process();return this._hash},clone:function(){var e=j.clone.call(this);e._hash=this._hash.clone();return e}});e.SHA1=j._createHelper(m);e.HmacSHA1=j._createHmacHelper(m)})();


var debridlinkplugin = {	
	
	prefObserver: null,
	
	stringBundle: null,
	
	JSON: null,

	init: function() {
		window.addEventListener("load", this.callInContext(this, 'chromeLoad'), false);
	},
	
	callInContext: function(o, m) {
		return function() {
			return o[m].apply(o, arguments);
		};
	},
	
	chromeLoad: function() {
		
		var contextmenu = document.getElementById("contentAreaContextMenu");
		var appcontent = document.getElementById("appcontent");
		
		contextmenu.addEventListener("popupshowing", this.callInContext(this, 'contextShowing'), false);
		appcontent.addEventListener("DOMContentLoaded", this.callInContext(this, 'contentLoaded'), true);
		
		// pour l'i18n
		this.stringBundle = document.getElementById('debridlink-strings');
	},
	
	

	_S: function(stringname) {
			return this.stringBundle.getString(stringname);
	},
	
	_FS: function(stringname, params) {
			return this.stringBundle.getFormattedString(stringname, params);
	},
	
	stringToPostData: function(str) {
		var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].
							createInstance(Components.interfaces.nsIStringInputStream);
		if ("data" in stringStream) { // Gecko 1.9 or newer
			stringStream.data = "lien="+str;
		} else { // 1.8 or older
			stringStream.setData("lien="+str, str.length+5);
		}
		var postData = Components.classes["@mozilla.org/network/mime-input-stream;1"].
						createInstance(Components.interfaces.nsIMIMEInputStream);
		postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
		postData.addContentLength = true;
		postData.setData(stringStream);
		return postData;
	},
	
	
    count: function(str){
        var tab = str.split(',');
		return tab.lenght;
    },
	
	
    debridContext: function(url, stream){
    	this.showNotification(null, true, 'Génération des liens en cours... Veuillez patienter', "debridlink-generate", null);
    	var self = this;
    	DL.addLink(url, function(){
    		var resp = JSON.parse(this.responseText);
    		if(resp.result == 'OK'){
    			self.showNotification(null, true, 'Fichier '+ resp.filename +' généré.', "debridlink-generated", null);
    			var regV = new RegExp(/(avi|mp4|flv|mkv)/g);								
				if(resp.filename.match(regV) && stream){//Stream
					window.open('http://webapp.debrid-link.fr/stream/?link='+ resp.downloadLink);
				}else{
					window.open(resp.downloadLink);
				}
    		}else{
    			self.showNotification(null, true, DL.error(resp.ERR), "debridlink-generated", null);
    		}
    	});
    },

	contentLoaded: function(e) {		
		var browsers = gBrowser.browsers; // un tableau de tout les objet browser ouverts
		var doc = e.originalTarget; // l'objet document qui a declenché l'event
		var debr = this;
		var thisbrowser;
		
		for(i = 0; i < browsers.length; i++) {
			// on verifie que le docu qui a declenché l'event est de top level (=pas dans une iframe)
			if(doc == browsers[i].contentDocument && this.verifyUrl(browsers[i].currentURI.spec) && !this.verifySite(browsers[i].currentURI.spec)) {
				thisbrowser = browsers[i];
				this.showNotification(
					thisbrowser,
					false, // si ya deja une notification, on affiche rien
					this._S('askdebrid'),
					"debridlinkplugin-frommegaupload",
					[{ // on défini le bouton "Débrider"
						callback: function(e) {
							debr.debridContext(thisbrowser.currentURI.spec,0);
						},
						label: this._S('debrid'),
						popup: null
					},{ // on défini le bouton "streaming"
						callback: function(e) {
							debr.debridContext(thisbrowser.currentURI.spec,1);
						},
						label: 'Streaming',
						popup: null
					}]					
				);
				break;
			}
		}
	},
		
	
	contextShowing: function() {
		if(((gContextMenu.onLink && this.verifyUrl(gContextMenu.linkURL)) || gContextMenu.isTextSelected)) {
			document.getElementById('debridlinkplugin-debrid').hidden = false;
			document.getElementById('debridlinkplugin-stream').hidden = false;
		}else{
			document.getElementById('debridlinkplugin-debrid').hidden = true;
			document.getElementById('debridlinkplugin-stream').hidden = true;
        }			
	},
	
	showNotification: function(browser, override, str, value,  buttons) {
		var notif = gBrowser.getNotificationBox(browser != null ? browser : gBrowser.selectedBrowser);
		notif.removeAllNotifications();
		notif.appendNotification(
			str,
			value,
			"chrome://debridlinkplugin/skin/icon/logo16.png",
			notif.PRIORITY_INFO_LOW,
			buttons
		);
	},
	
	/**
	 * Detecte les URLs valides dans un block de texte.
	 */
	detectUrls: function(text) {
		var regex = /(http|https):\/\/(?:.*\.)?(?:oboom|1fichier|alterupload|cjoint|desfichiers|dfichiers|megadl|mesfichiers|piecejointe|pjointe|tenvoi|dl4free|ul|2shared|4shared|bayfiles|crocko|filecloud|filefactory|filemonkey|firedrive|freakshare|letitbit|mixture-cloud|netload|nowvideo|purevid|queenshare|shareflare|sockshare|terafile|turbobit|uploaded|uploading|uptobox|vip-file|youwatch|mixturecloud)\.(?:.*)\/(?:.*)/gi;
		var tmpresult;
		var result = new Array();
		
		while((tmpresult = regex.exec(text)) != null) {
			result.push(tmpresult[0]);
		}
		
		if(result.length > 0) return result;
		
		return false;
	},
	
	/**
	 * Vérifie une url.
	 */
	verifyUrl: function(url) {
		var regex = /^(http|https):\/\/(?:.*\.)?(?:oboom|1fichier|alterupload|cjoint|desfichiers|dfichiers|megadl|mesfichiers|piecejointe|pjointe|tenvoi|dl4free|ul|2shared|4shared|bayfiles|crocko|filecloud|filefactory|filemonkey|firedrive|freakshare|letitbit|mixture-cloud|netload|nowvideo|purevid|queenshare|shareflare|sockshare|terafile|turbobit|uploaded|uploading|uptobox|vip-file|youwatch|mixturecloud)\.(?:.*)\/(?:.*)$/i;
		return regex.test(url);
	},
	verifySite: function(url) {
		var regex = /^http:\/\/(?:.*\.)?(?:debrid-link)\.(?:.*)\/(?:.*)$/i;
		return regex.test(url);
	},	
	
	contextClicked: function(stream) {
		if(gContextMenu.isTextSelected) {
			// on recupere la selection et on detecte les url dedans
			var txt = gContextMenu.target.ownerDocument.defaultView.getSelection();
			var result = this.detectUrls(txt);
			var debr = this;
			
			if(result != false) {
					this.debridContext(result, stream);
			} else {
				this.showNotification(null, false, this._S('couldnotfindanyurl'), "debridlink-invalidselection", null);
			}
		} else if(gContextMenu.onLink) {
			if(this.verifyUrl(gContextMenu.linkURL)) {
			    this.debridContext(gContextMenu.linkURL, stream);
			} else {
				this.showNotification(null, false, this._S('invalidlink'), "debridlink-invalidlink", null);
			}
		}
	},	 
};

/*
 * © 2014 Debrid-link.fr, All rights reserved
 * Date : 2014-04-2014
 * By GhostDim
 */

var DL = {

	API_URL : "https://api.debrid-link.fr/1.1",
	APP_KEY : "oKrpYeoeKN7F0ryi",
	loadToken : false,
	prefs : false,

	infoMember : function(callback){
		this._request({data : {
			r : 'infoMember'
		}}, callback);
	},

	error : function(ERR){
		switch(ERR){
			case 'notDebrid' : return "Le fichier n'a pas été débridé."; break;
			case 'fileNotFound' : return "Le fichier n'est pas présent sur l'hébergeur."; break;
			case 'badFileUrl' : return "Le format du lien est invalide."; break;
			case 'hostNotValid' : return "L'hébergeur n'est pas supporté."; break;
			case 'disabledHost' : return "L'hébergeur est en maintenance."; break;
			case 'noGetFilename' : return "Impossible de récupérer le nom du fichier."; break;
			case 'notGetTorrentFile' : return "Impossible de récupérer le fichier torrent."; break;
			case 'badTorrentFile' : return "Le fichier ne semble pas être un torrent."; break;
			case 'notAddTorrent' : return "Impossible de trouver un serveur"; break;
			case 'notPts' : return "Vous n'avez pas assez de points sur votre compte."; break;
			case 'duplicateTorrent' : return "Le torrent a déjà été ajouté."; break;
			default : return "Erreur #"+ ERR;
		}
	},

	/*
	 * Add link to account
	 */
	addLink : function(link, callback){
		this._request({data : {
			r : 'addLink',
			link : link}
		},callback);
	},

	/*
	 * Request to the API
	 * @param args {object}
	 * @param callback {function} - Callback function
	 */
	_request : function(args, callback){

		if(this.prefs === false){
			this.prefs = Components .classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
        	this.prefs = this.prefs.getBranch('extensions.tntfixer.');
        }

		var self = this;
		var restart = (typeof arguments[2] == 'undefined') ? 0 : arguments[2];

		//No token, create
		if(!this._getToken() && args.data.r != 'getToken'){
			this._createToken();
			return;
		}

		//Add token and sign
		if(args.data.r != 'getToken'){
			args.data.token = this._getToken();
			args.data.sign = this._build_sign(args.data);
		}

		var xhr = new XMLHttpRequest();
		xhr.open("GET", this.API_URL + "/?"+ this._build_querry(args.data), true);
		xhr.onreadystatechange = function() {
		  	if(xhr.readyState == 4){
		  		var resp = JSON.parse(this.responseText);
		  		if(typeof resp.ts !== undefined){
		  			self._setTSD(Math.round(new Date().getTime() / 1000 - resp.ts));
		  		}
		  		//Good request
		  		if(resp.result == 'OK'){
		  			// Delete infos stored
		  			if(args.data.r == 'logout'){
		  				self._destroy();
		  			}
		  	  	}else{
		  	  		//Bad sign restart
		  	  		if(restart < 2 && resp.ERR == 'badSign'){
		  	  			self._request(args, callback, restart++);
		  	  			return;
		  	  		}
		  	  		//bad token, get new token
		  	  		if(resp.ERR == 'badToken'){
		  	  			self._destroy();
		  	  			self._createToken();
		  	  		}
		  	  		//Token is disabled, redirect for enabled
		  	  		if(resp.ERR == 'hidedToken'){
		  	  			window.open(resp.validTokenUrl);
		  	  		}
		  	  	}

		  	  	if(typeof callback == "function"){
		  	  		callback.apply(xhr);
		  	  	}
  			}
		}
		xhr.send();
	},

	/*
	 * Get the token to API
	 */
	_createToken : function(){
		if(!this.loadToken){
			var self = this;
			this.loadToken = true;
			this._request({'data' : {
				r : 'getToken', 
				publickey : this.APP_KEY
			}}, function(){ 
				self._callback_getToken(this);
			});
		}
	},

	_callback_logout: function(xhr){
		var resp = JSON.parse(xhr.responseText);
		if(resp.result == 'OK'){
			this._destroy();
		}
	},

	/* 
	 * Callback to get the token
	 */
	_callback_getToken : function(xhr){
		var resp = JSON.parse(xhr.responseText);
		if(resp.result == 'OK'){
			if(this.loadToken){
				this._loadToken = false;
				this._setToken(resp.token);
				this._setKey(resp.key);
				window.open(resp.validTokenUrl);
			}
		}

	},

	/*
	 * Create a SHA1 Sign for the request
	 * @param a {object} The querry object
	 */
    _build_sign : function(a){
		return CryptoJS.SHA1(this._getTS() + a.r + this._getKey()).toString();
    },

    /*
     * Create a HTTP querry
     * @param a {object} The querry object
     */
	_build_querry : function(a){
		var s = "";
		for(key in a){
			s += key +"="+ a[key] +"&";
		}
		return s.substring(0,s.length-1);
	},

	/*
	 * Destroy the local storage
	 */
	_destroy : function(){
		this._setKey(false);
		this._setToken(false);
	},

	/*
	 * Store the token
	 * @param token {string} The token to store
	 */
	_setToken : function(token){
		this.prefs.setCharPref('token', token);
	},

	/*
	 * Get the stored token
	 * @return {string}
	 */
	_getToken : function(){
		try{
			return this.prefs.getCharPref('token');
		}catch (err){
			return;
		}
	},

	/*
	 * Store the private key
	 * @param key {string} The key to store
	 */
	_setKey : function(key){
		this.prefs.setCharPref('key', key);
	},

	/*
	 * Get the private key
	 * @return {string}
	 */
	_getKey : function(){
		try{
			return this.prefs.getCharPref('key');
		}catch (err){
			return;
		}
	},

	/*
	 * Get the Timestamp synchronized with the API
	 */
	_getTS : function(){
		return Math.round(new Date().getTime() / 1000 - this._getTSD());
	},

	/* 
	 * Store the diference timesamp client <-> Serveur
	 * @param TSD - The diference timesamp
	 */
	_setTSD : function(TSD){
		this.prefs.setCharPref('TSD', TSD);
	},

	_getTSD : function(){
		try{
			return this.prefs.getCharPref('TSD');
		}catch (err){
			return 0;
		}
	}


};

debridlinkplugin.init();
